function InstSet = FindInstThroughMustLinks(Seed, MustLink)
% Find the set of instances that are connected to Seed through must-links
%
% Input: 
%   - Seed      : a row vector of the starting instances
%   - MustLink  : the must-link cell
% Ouput:
%   - InstSet   : the set of instances that are connected to Seed through
%                 must-links
%
% Author: Zhiyao Duan
% Created: 6/20/2012
% Last modified: 6/20/2012

% initialize the set
InstSetSize = length(Seed);
InstSet(1:InstSetSize) = Seed;

p = 1;                                          % the pointer
while p <= InstSetSize                          % we haven't consider all instances in this set
    % try each connected instance connected to the p-th instance in the set
    for j = MustLink{InstSet(p)}
        if ~any(InstSet==j)                     % prevent duplicates
            InstSetSize = InstSetSize + 1;
            InstSet(InstSetSize) = j;
        end
    end
    p = p + 1;
end