function F0Group = MapF0ToGroup(Group, feaNum)
% Find the mapping from F0s (vertices) to vertex groups
% Input
%   - Group         : vertex groups, each row is a group
%   - feaNum        : number of vertices
% Output
%   - F0Group       : the mapping from F0s (vertices) to vertex groups
% 
% Author: Zhiyao Duan
% Created: 5/28/2009
% Last modified: 6/15/2012


F0Group = zeros(feaNum, 1);

groupNum = length(Group);
for i = 1:groupNum
    F0Group(Group{i}) = i;      % Group{i} is a vector of F0s indicies
end

if sum(F0Group==0) ~= 0         % Error: Some vertex is not in any group!
    sprintf('Error: Some vertex is not in any group!\n');
end